/**
Checks the type of a data point element and returns the integer used to represent this data type
	depending on the required type of peripheral address.

	NOTE: this function is mostly redundant now as OPC supports the default data transformation now.
	The results for address type DIM are also redundant now.

@par Constraints
	None

@par Usage
	Internal

@par PVSS managers
	VISION, CTRL

@param dataType			The integer representing the data type is returned here (returns -1 if dpe type is unsupported)
@param dpe					The data point element to check
@param addressType	The type of peripheral address (DIM or OPC)


@Deprecated 2018-08-01

*/
fwPeriphAddress_getDataType(int &dataType, string dpe, string addressType)
{

  FWDEPRECATED();

	switch(dpElementType(dpe))
	{
		case DPEL_BOOL:
			if(addressType == "OPC")
			{
				dataType = 486;
			}
			else
			{
				dataType = 2002;
			}
			break;
		case DPEL_INT:
			if(addressType == "OPC")
			{
				dataType = 481;
			}
			else
			{
				dataType = 2002;
			}
			break;
		case DPEL_STRING:
			if(addressType == "OPC")
			{
				dataType = 487;
			}
			else
			{
				dataType = 2001;
			}
			break;
		case DPEL_FLOAT:
			if(addressType == "OPC")
			{
				dataType = 484;
			}
			else
			{
				dataType = 2003;
			}
			break;
		case DPEL_DYN_BOOL:
			if(addressType == "OPC")
			{
				dataType = -1;
			}
			else
			{
				dataType = 2004;
			}
			break;
		case DPEL_DYN_FLOAT:
			if(addressType == "OPC")
			{
				dataType = -1;
			}
			else
			{
				dataType = 2005;
			}
			break;
		default:
			dataType = -1;
			break;
	}
}






/**
Get formatted address for Unicos using given parameters

@par Constraints
	None

@par Usage
	Public

@par PVSS managers
	VISION, CTRL

@param dsParameters				parameters used to build the address reference (see constants definition)
@param addressReference		address reference (empty string in case of error)

@Deprecated 2018-08-01

*/
fwPeriphAddress_getUnicosAddressReference(dyn_string dsParameters, string& addressReference)
{

  FWDEPRECATED();

	int mode, iPLCNumber, address;
	string sPLCType;
	bool event;
	bool dataOk = true;
	string temp;

	// 1. Check input data
	if (dynlen(dsParameters) == UN_ADDRESS_PARAMETER_FIELD_NUMBER)
	{
		if (sscanf(dsParameters[UN_ADDRESS_PARAMETER_FIELD_MODE], "%d", mode) <= 0)
		{
			dataOk = false;
		}
		sPLCType = dsParameters[UN_ADDRESS_PARAMETER_FIELD_PLCTYPE];
		if ((sPLCType != "QUANTUM") && (sPLCType != "PREMIUM"))
		{
			dataOk = false;
		}
		if (sscanf(dsParameters[UN_ADDRESS_PARAMETER_FIELD_PLCNUMBER], "%d", iPLCNumber) <= 0)
		{
			dataOk = false;
		}
		temp = strtolower(dsParameters[UN_ADDRESS_PARAMETER_FIELD_EVENT]);
		if ((temp != "false") && (temp != "true") && (temp != "0") && (temp != "1"))
		{
			dataOk = false;
		}
		event = (bool)dsParameters[UN_ADDRESS_PARAMETER_FIELD_EVENT];
		if (sscanf(dsParameters[UN_ADDRESS_PARAMETER_FIELD_ADDRESS], "%d", address) <= 0)
		{
			dataOk = false;
		}
	}
	else
	{
		dataOk = false;
	}

	// 2. Build formatted address
	addressReference = "";
	if (dataOk)
	{
		switch	(mode)
		{
			// Input
			case DPATTR_ADDR_MODE_INPUT_SPONT:
			case DPATTR_ADDR_MODE_INPUT_SQUERY:
			case DPATTR_ADDR_MODE_INPUT_POLL:
				switch (sPLCType)
				{
					case "PREMIUM":
						if (event)
						{
							addressReference = UN_PREMIUM_INPUT_LETTER_EVENT + "." + iPLCNumber + "." + UN_PREMIUM_INPUT_NB_EVENT + "." + address;
						}
						else
						{
							addressReference = UN_PREMIUM_INPUT_LETTER_MISC + "." + iPLCNumber + "." + UN_PREMIUM_INPUT_NB_MISC + "." + address;
						}
						break;

					case "QUANTUM":
						if (event)
						{
							addressReference = UN_QUANTUM_INPUT_LETTER_EVENT + "." + iPLCNumber + "." + UN_QUANTUM_INPUT_NB_EVENT + "." + address;
						}
						else
						{
							addressReference = UN_QUANTUM_INPUT_LETTER_MISC + "." + iPLCNumber + "." + UN_QUANTUM_INPUT_NB_MISC + "." + address;
						}
						break;

					default:
						break;
				}
				break;

			// Output
			case DPATTR_ADDR_MODE_OUTPUT:
			case DPATTR_ADDR_MODE_OUTPUT_SINGLE:
				addressReference = UN_PREMIUM_QUANTUM_OUTPUT_LETTER_ALL + "." +
								   iPLCNumber + "." +
								   UN_PREMIUM_QUANTUM_OUTPUT_NB_ALL + "." +
								   address;
				break;

			// Unknown
			case DPATTR_ADDR_MODE_UNDEFINED:
			default:
				break;
		}
	}
}
/** DEPRECATED - function to get the Unit of several dpes

Function is replaced by fwUnit_getMany

@Deprecated 2018-08-02

*/
fwUnit_getMultiple(dyn_string dsDpe, dyn_bool &dbUnitExists, dyn_string &dsUnit, dyn_string &exceptionInfo)
{

  FWDEPRECATED();

	fwUnit_getMany(dsDpe, dbUnitExists, dsUnit, exceptionInfo);
}/** DEPRECATED - function to get the Format of several dpes

Function is replaced by fwFormat_getMany

@Deprecated 2018-08-01

*/
fwFormat_getMultiple(dyn_string dsDpe, dyn_bool &dbFormatExists, dyn_string &dsFormat, dyn_string &exceptionInfo)
{

  FWDEPRECATED();

	fwFormat_getMany(dsDpe, dbFormatExists, dsFormat, exceptionInfo);
}